<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="formEditRestaurantType"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="12">
            <el-form-item label="种类名称" prop="RestaurantType.name">
              <el-input
                class="input-item"
                v-model="formData.RestaurantType.name"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="14">
            <el-form-item label="种类图标" prop="RestaurantType.url">
              <el-upload
                class="upload-image-item"
                name="uploadFile"
                :headers="getUploadHeaders"
                :action="getUploadActionUrl('/admin/app/restaurantType/upload')"
                :data="{fieldName: 'url', asImage: true}"
                :on-success="onUrlUploadSuccess"
                :on-remove="onUrlRemoveFile"
                :on-error="onUploadError"
                :show-file-list="false"
              >
              <div v-if="urlWidgetFileList && urlWidgetFileList[0] != null" style="position: relative">
                <img class="upload-image-show"
                  :src="urlWidgetFileList[0].url" />
                <div class="upload-img-del el-icon-close"
                  @click.stop="onUrlRemoveFile(null, null)" />
              </div>
              <i v-else class="el-icon-plus upload-image-item"></i>
              </el-upload>
            </el-form-item>
          </el-col>
          <el-col :span="14">
            <el-form-item label="是否启用" prop="RestaurantType.enable">
              <el-radio-group
                class="input-item"
                v-model="formData.RestaurantType.enable"
              >
                <el-radio
                  v-for="item in enableWidgetDropdownList"
                  :key="item.id"
                  :label="item.id"
                >
                  {{ item.name }}
                </el-radio>
              </el-radio-group>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="显示顺序" prop="RestaurantType.showOrder">
              <el-input-number
                class="input-item"
                v-model="formData.RestaurantType.showOrder"
                placeholder=""
                :clearable="true"
                :step="1"
                :controls="true"
              />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onSaveClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formEditRestaurantType',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode } from '@/common/utils';
import { RestaurantTypeData } from '@/api/generated/restaurantTypeController';
import { RestaurantTypeController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const formEditRestaurantType = ref();
// 表单数据定义
type FormEditRestaurantTypeData = {
  RestaurantType: RestaurantTypeData;
};
// 表单数据
const formData = reactive<FormEditRestaurantTypeData>({
  RestaurantType: {
    // 主键id
    id: undefined,
    // 种类名称
    name: undefined,
    // 种类图标
    url: undefined,
    // 是否启用，0禁用，1启用
    enable: undefined,
    // 显示顺序
    showOrder: undefined,
    // 创建用户
    createUserId: undefined,
    // 创建时间
    createTime: undefined,
    // 更新用户
    updateUserId: undefined,
    // 更新时间
    updateTime: undefined,
    // 删除标记(1: 正常 -1: 已删除)
    dataState: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'RestaurantType.url': [
    {required: true, message: '请输入种类图标', trigger: 'blur'}
  ],
  'RestaurantType.enable': [
    {required: true, message: '请输入是否启用', trigger: 'blur'}
  ],
  'RestaurantType.showOrder': [
    {required: true, message: '请输入显示顺序', trigger: 'blur'}
  ],
  'RestaurantType.name': [
    {required: true, message: '请输入种类名称', trigger: 'blur'}
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadRestaurantTypeData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.RestaurantType = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    RestaurantTypeController.view(params).then(res => {
      formData.RestaurantType = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 种类图标上传成功
 */
const onUrlUploadSuccess = (
  response: ANY_OBJECT,
  file: UploadFile,
  fileList: UploadFile[],
) => {
  if (response.success) {
    file.downloadUri = response.data.downloadUri;
    file.filename = response.data.filename;
    file.uploadPath = response.data.uploadPath;
    file.url = URL.createObjectURL(file.raw);
    urlWidget.onFileChange(file, fileList);
    formData.RestaurantType.url = fileListToJson(urlWidgetFileList.value);
  } else {
    ElMessage.error(response.message);
  }
};
/**
 * 移除种类图标
 */
const onUrlRemoveFile = (file: UploadFile | null, fileList: UploadFile[] | null) => {
  urlWidget.onFileChange(file, fileList);
  formData.RestaurantType.url = fileListToJson(urlWidgetFileList);
};
// 种类图标上传文件组件
const urlWidget = useUploadWidget(1);
const { fileList: urlWidgetFileList, maxCount: urlWidgetMaxCount } = urlWidget;
/**
 * 是否启用下拉数据获取函数
 */
const loadEnableDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.Enable.getList(),
  });
};
// 是否启用配置参数
const enableOptions: DropdownOptions<DictData> = {
  loadData: loadEnableDropdownList,
  isTree: false,
};
// 是否启用下拉组件
const enableWidget = useDropdown(enableOptions);
const { dropdownList: enableWidgetDropdownList } = enableWidget
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshFormEditRestaurantType = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetFormEditRestaurantType = () => {
  refreshFormEditRestaurantType();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormEditRestaurantType();
};
/**
 * 保存
 */
const onSaveClick = () => {
  formEditRestaurantType.value.validate((valid) => {
    if (!valid) return;
    // 级联操作
    if (!props.saveOnSubmit) {
      let formData = {
        ...formData.RestaurantType
      };
    formData.enableDictMap = findItemFromList(enableWidgetDropdownList, formData.enable, 'id');
  props.dialog?.submit(formData);
      return;
    }
    let params: ANY_OBJECT = {
      restaurantTypeDto: {
        id: formData.RestaurantType.id,
        name: formData.RestaurantType.name,
        url: formData.RestaurantType.url,
        enable: formData.RestaurantType.enable,
        showOrder: formData.RestaurantType.showOrder,
        createUserId: formData.RestaurantType.createUserId,
        createTime: formData.RestaurantType.createTime,
        updateUserId: formData.RestaurantType.updateUserId,
        updateTime: formData.RestaurantType.updateTime,
      }
    };

    let httpCall = isEdit.value ? RestaurantTypeController.update : RestaurantTypeController.add;
    httpCall(params).then(res => {
      ElMessage.success('保存成功');
      props.dialog?.submit();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  });
};
const formInit = () => {
  loadRestaurantTypeData().then(res => {
    let urlDownloadParams = {
      id: formData.RestaurantType.id,
      fieldName: 'url',
      asImage: true
    };
    urlWidgetFileList.value = parseUploadData(formData.RestaurantType.url, urlDownloadParams);
    enableWidget.onVisibleChange(true).catch(e => {console.error(e)});
    if (isEdit.value) refreshFormEditRestaurantType();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
});
</script>
